Index: /trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1413)
@@ -5308,10 +5301,38 @@
 }
 
+#if MCTS_ENC_CHECK
+Void TEncSearch::xInitTileBorders(const TComDataCU* const pcCU, TComPattern* pcPatternKey)
+{
+  if (m_pcEncCfg->getTMCTSSEITileConstraint())
+  {
+    UInt  tileXPosInCtus = 0;
+    UInt  tileYPosInCtus = 0;
+    UInt  tileWidthtInCtus = 0;
+    UInt  tileHeightInCtus = 0;
+
+    getTilePosition(pcCU, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus);
+
+    const Int  ctuLength = pcCU->getPic()->getPicSym()->getSPS().getMaxCUWidth();
+
+    // tile position in full pels
+    const Int tileLeftTopPelPosX = ctuLength * tileXPosInCtus;
+    const Int tileLeftTopPelPosY = ctuLength * tileYPosInCtus;
+    const Int tileRightBottomPelPosX = ((tileWidthtInCtus + tileXPosInCtus) * ctuLength) - 1;
+    const Int tileRightBottomPelPosY = ((tileHeightInCtus + tileYPosInCtus) * ctuLength) - 1;
+
+    pcPatternKey->setTileBorders (tileLeftTopPelPosX,tileLeftTopPelPosY,tileRightBottomPelPosX,tileRightBottomPelPosY);
+  }
+}
+#endif
 
 Void TEncSearch::xSetSearchRange ( const TComDataCU* const pcCU, const TComMv& cMvPred, const Int iSrchRng,
+#if MCTS_ENC_CHECK
+                                   TComMv& rcMvSrchRngLT, TComMv& rcMvSrchRngRB, const TComPattern* const pcPatternKey )
+#else
                                    TComMv& rcMvSrchRngLT, TComMv& rcMvSrchRngRB )
+#endif
 {
   Int  iMvShift = 2;
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( pcCU->getSlice()->getIsDepth() )
   {
@@ -5322,4 +5343,27 @@
   pcCU->clipMv( cTmpMvPred );
 
+#if MCTS_ENC_CHECK
+  if (m_pcEncCfg->getTMCTSSEITileConstraint())
+  {
+    const Int lRangeXLeft = max(cTmpMvPred.getHor() - (iSrchRng << iMvShift), (pcPatternKey->getTileLeftTopPelPosX() - pcPatternKey->getROIYPosX()) << iMvShift);
+    const Int lRangeYTop = max(cTmpMvPred.getVer() - (iSrchRng << iMvShift), (pcPatternKey->getTileLeftTopPelPosY() - pcPatternKey->getROIYPosY()) << iMvShift);
+    const Int lRangeXRight = min(cTmpMvPred.getHor() + (iSrchRng << iMvShift), (pcPatternKey->getTileRightBottomPelPosX() - (pcPatternKey->getROIYPosX() + pcPatternKey->getROIYWidth())) << iMvShift);
+    const Int lRangeYBottom = min(cTmpMvPred.getVer() + (iSrchRng << iMvShift), (pcPatternKey->getTileRightBottomPelPosY() - (pcPatternKey->getROIYPosY() + pcPatternKey->getROIYHeight())) << iMvShift);
+
+    rcMvSrchRngLT.setHor(lRangeXLeft);
+    rcMvSrchRngLT.setVer(lRangeYTop);
+
+    rcMvSrchRngRB.setHor(lRangeXRight);
+    rcMvSrchRngRB.setVer(lRangeYBottom);
+  }
+  else
+  {
+    rcMvSrchRngLT.setHor(cTmpMvPred.getHor() - (iSrchRng << iMvShift));
+    rcMvSrchRngLT.setVer(cTmpMvPred.getVer() - (iSrchRng << iMvShift));
+
+    rcMvSrchRngRB.setHor( cTmpMvPred.getHor() + (iSrchRng << iMvShift));
+    rcMvSrchRngRB.setVer( cTmpMvPred.getVer() + (iSrchRng << iMvShift) );
+  }
+#else
   rcMvSrchRngLT.setHor( cTmpMvPred.getHor() - (iSrchRng << iMvShift) );
   rcMvSrchRngLT.setVer( cTmpMvPred.getVer() - (iSrchRng << iMvShift) );
@@ -5327,5 +5371,5 @@
   rcMvSrchRngRB.setHor( cTmpMvPred.getHor() + (iSrchRng << iMvShift) );
   rcMvSrchRngRB.setVer( cTmpMvPred.getVer() + (iSrchRng << iMvShift) );
-  
+  #endif
 #if NH_MV
   if ( m_vertRestriction )
@@ -5394,8 +5438,6 @@
       m_cDistParam.bitDepth = pcPatternKey->getBitDepthY();
 
-#if NH_3D_IC
+#if NH_3D
       m_cDistParam.bUseIC = pcPatternKey->getICFlag();
-#endif
-#if NH_3D_SDC_INTER
       m_cDistParam.bUseSDCMRSAD = pcPatternKey->getSDCMRSADFlag();
 #endif
@@ -5500,5 +5542,5 @@
   UInt uiSearchRange = m_iSearchRange;
   pcCU->clipMv( rcMv );
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( ! pcCU->getSlice()->getIsDepth() )
 #endif
@@ -5525,15 +5567,15 @@
       TComMv cMv = m_acMvPredictors[index];
       pcCU->clipMv( cMv );
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
       if( ! pcCU->getSlice()->getIsDepth() )
       {      
 #endif
 #if ME_ENABLE_ROUNDING_OF_MVS
-      cMv.divideByPowerOf2(2);
+        cMv.divideByPowerOf2(2);
 #else
-      cMv >>= 2;
-#endif
-
-#if NH_3D_INTEGER_MV_DEPTH
+        cMv >>= 2;
+#endif
+
+#if NH_3D
       }
 #endif
@@ -5585,5 +5627,9 @@
     TComMv currBestMv(cStruct.iBestX, cStruct.iBestY );
     currBestMv <<= 2;
+#if MCTS_ENC_CHECK
+    xSetSearchRange(pcCU, currBestMv, iSrchRng, cMvSrchRngLT, cMvSrchRngRB, pcPatternKey);
+#else
     xSetSearchRange( pcCU, currBestMv, iSrchRng, cMvSrchRngLT, cMvSrchRngRB );
+#endif
     iSrchRngHorLeft   = cMvSrchRngLT.getHor();
     iSrchRngHorRight  = cMvSrchRngRB.getHor();
@@ -5875,5 +5921,9 @@
     TComMv currBestMv(cStruct.iBestX, cStruct.iBestY );
     currBestMv <<= 2;
+#if MCTS_ENC_CHECK
+    xSetSearchRange(pcCU, currBestMv, iSrchRng, cMvSrchRngLT, cMvSrchRngRB, pcPatternKey);
+#else
     xSetSearchRange( pcCU, currBestMv, iSrchRng, cMvSrchRngLT, cMvSrchRngRB );
+#endif
     iSrchRngHorLeft   = cMvSrchRngLT.getHor();
     iSrchRngHorRight  = cMvSrchRngRB.getHor();
@@ -5976,5 +6026,14 @@
                           pcPatternKey->getROIYHeight(),
                           iRefStride,
+#if MCTS_ENC_CHECK
+                          pcPatternKey->getBitDepthY(),
+                          pcPatternKey->getROIYPosX(),
+                          pcPatternKey->getROIYPosY());
+#else
                           pcPatternKey->getBitDepthY());
+#endif
+#if MCTS_ENC_CHECK
+  cPatternRoi.setTileBorders(pcPatternKey->getTileLeftTopPelPosX(), pcPatternKey->getTileLeftTopPelPosY(), pcPatternKey->getTileRightBottomPelPosX(), pcPatternKey->getTileRightBottomPelPosY());
+#endif
 
   //  Half-pel refinement
@@ -6052,5 +6111,5 @@
     m_pcEntropyCoder->resetBits();
 
-    if (pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+    if (pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
     {
       m_pcEntropyCoder->encodeCUTransquantBypassFlag(pcCU, 0, true);
@@ -6059,8 +6118,6 @@
     m_pcEntropyCoder->encodeSkipFlag(pcCU, 0, true);
     m_pcEntropyCoder->encodeMergeIndex( pcCU, 0, true );
-#if NH_3D_ARP
+#if NH_3D
     m_pcEntropyCoder->encodeARPW( pcCU, 0 );
-#endif
-#if NH_3D_IC
     m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
 #endif
@@ -6176,5 +6233,5 @@
   const Double zeroCost     = (pcCU->isLosslessCoded( 0 )) ? (nonZeroCost+1) : (m_pcRdCost->calcRdCost( zeroResiBits, zeroDistortion ));
 #endif
-#if NH_3D_SPIVMP
+#if NH_3D
     if ( zeroCost < nonZeroCost || pcCU->getQtRootCbf(0)==0)
 #else
@@ -6272,5 +6329,5 @@
 }
 
-#if NH_3D_SDC_INTER
+#if NH_3D
 Void TEncSearch::encodeResAndCalcRdInterSDCCU( TComDataCU* pcCU, TComYuv* pcOrg, TComYuv* pcPred, TComYuv* pcResi, TComYuv* pcRec, Int uiOffest, const UInt uiDepth )
 {
@@ -6600,5 +6657,6 @@
               if ((compID != COMPONENT_Cr) && ((transformSkipModeId == 1) ? m_pcEncCfg->getUseRDOQTS() : m_pcEncCfg->getUseRDOQ()))
               {
-                m_pcEntropyCoder->estimateBit(m_pcTrQuant->m_pcEstBitsSbac, tuCompRect.width, tuCompRect.height, toChannelType(compID));
+                COEFF_SCAN_TYPE scanType = COEFF_SCAN_TYPE(pcCU->getCoefScanIdx(uiAbsPartIdx, tuCompRect.width, tuCompRect.height, compID));
+                m_pcEntropyCoder->estimateBit(m_pcTrQuant->m_pcEstBitsSbac, tuCompRect.width, tuCompRect.height, toChannelType(compID), scanType);
               }
 
@@ -7365,5 +7423,5 @@
   // Reload only contexts required for coding intra mode information
   m_pcRDGoOnSbacCoder->loadIntraDirMode( m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST], chType );
-#if NH_3D_DMM
+#if NH_3D
   if( pcCU->getSlice()->getIsDepth() && isLuma(chType) )
   {
@@ -7442,5 +7500,5 @@
 
     m_pcEntropyCoder->resetBits();
-    if(pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+    if(pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
     {
       m_pcEntropyCoder->encodeCUTransquantBypassFlag(pcCU, 0, true);
@@ -7448,8 +7506,6 @@
     m_pcEntropyCoder->encodeSkipFlag(pcCU, 0, true);
     m_pcEntropyCoder->encodeMergeIndex(pcCU, 0, true);
-#if NH_3D_ARP
+#if NH_3D
     m_pcEntropyCoder->encodeARPW( pcCU, 0 );
-#endif
-#if NH_3D_IC
     m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
 #endif
@@ -7460,5 +7516,5 @@
     m_pcEntropyCoder->resetBits();
 
-    if(pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+    if(pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
     {
       m_pcEntropyCoder->encodeCUTransquantBypassFlag(pcCU, 0, true);
@@ -7466,5 +7522,5 @@
 
     m_pcEntropyCoder->encodeSkipFlag ( pcCU, 0, true );
-#if NH_3D_DIS
+#if NH_3D
     m_pcEntropyCoder->encodeDIS ( pcCU, 0, true );
 #endif
@@ -7472,14 +7528,8 @@
     m_pcEntropyCoder->encodePartSize( pcCU, 0, pcCU->getDepth(0), true );
     m_pcEntropyCoder->encodePredInfo( pcCU, 0 );
-#if NH_3D_SDC_INTRA
+#if NH_3D
     m_pcEntropyCoder->encodeSDCFlag( pcCU, 0, true );
-#endif
-#if NH_3D_ARP
     m_pcEntropyCoder->encodeARPW( pcCU , 0  );
-#endif
-#if NH_3D_IC
     m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
-#endif
-#if NH_3D_DBBP
     m_pcEntropyCoder->encodeDBBPFlag( pcCU, 0, true );
 #endif
@@ -7752,5 +7802,5 @@
 }
 
-#if NH_3D_DMM
+#if NH_3D
   // -------------------------------------------------------------------------------------------------------------------
   // Depth intra search
@@ -7907,8 +7957,6 @@
 #endif
 
-#if NH_3D_DLT
   rDeltaDC1 = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), ClipBD(predDC1 + rDeltaDC1, bitDepthY )) - pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), predDC1 );
   rDeltaDC2 = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), ClipBD(predDC2 + rDeltaDC2, bitDepthY )) - pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), predDC2 );
-#endif
 }
 
@@ -8027,6 +8075,4 @@
 }
 
-#endif
-#if NH_3D_SDC_INTRA
 Void TEncSearch::xCalcConstantSDC( Pel* ptrSrc, UInt srcStride, UInt uiSize, Pel& valDC )
 {
Index: /trunk/source/Lib/TLibEncoder/TEncSearch.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSearch.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSearch.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -178,5 +178,5 @@
                                   Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE]
                                   DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                 , Bool        bOnlyIVP
 #endif
@@ -190,5 +190,5 @@
                                   Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE]
                                   DEBUG_STRING_FN_DECLARE(sDebug));
-#if NH_3D_DIS
+#if NH_3D
   Void  estIntraPredDIS        ( TComDataCU* pcCU, 
                                  TComYuv*    pcOrgYuv, 
@@ -225,5 +225,5 @@
                                   Bool        bSkipResidual
                                   DEBUG_STRING_FN_DECLARE(sDebug) );
-#if NH_3D_SDC_INTER
+#if NH_3D
   Void encodeResAndCalcRdInterSDCCU( TComDataCU* pcCU,
                                      TComYuv* pcOrg, 
@@ -281,5 +281,5 @@
                                     DEBUG_STRING_FN_DECLARE(sTest)
                                          ,Int           default0Save1Load2 = 0
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                   , Bool          zeroResiFlag = false
 #endif
@@ -301,5 +301,5 @@
                                     TComTU      &rTu
                                     DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                   , Bool        zeroResiFlag = false
 #endif
@@ -342,5 +342,5 @@
   Void  xStoreIntraResultQT       ( const ComponentID compID, TComTU &rTu);
   Void  xLoadIntraResultQT        ( const ComponentID compID, TComTU &rTu);
-#if NH_3D_DIS
+#if NH_3D
 #if NH_3D_VSO
   Void xIntraCodingDIS           ( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist&       ruiDist, Double& dRDCost, UInt uiPredMode );
@@ -350,5 +350,5 @@
 #endif
 
-#if NH_3D_DMM
+#if NH_3D
   // -------------------------------------------------------------------------------------------------------------------
   // Depth intra search
@@ -358,6 +358,4 @@
   Void xSearchDmmDeltaDCs         ( TComDataCU* pcCU, UInt uiAbsPtIdx, Pel* piOrig, Pel* piPredic, UInt uiStride, Bool* biSegPattern, Int patternStride, UInt uiWidth, UInt uiHeight, Pel& rDeltaDC1, Pel& rDeltaDC2 );
   Void xSearchDmm1Wedge           ( TComDataCU* pcCU, UInt uiAbsPtIdx, Pel* piRef, UInt uiRefStride, UInt uiWidth, UInt uiHeight, UInt& ruiTabIdx );
-#endif
-#if NH_3D_SDC_INTRA
 #if NH_3D_VSO
   Void xIntraCodingSDC            ( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist& ruiDist      , Double& dRDCost, Bool bZeroResidual, Int iSDCDeltaResi    );
@@ -419,9 +417,9 @@
                                     UChar*       uhInterDirNeighbours,
                                     Int&         numValidMergeCand
-#if NH_3D_VSP
-                                  , Int* vspFlag
-#endif
-#if NH_3D_SPIVMP
-                                  , Bool* pbSPIVMPFlag, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
+#if NH_3D
+                                  , Int*         vspFlag
+                                  , Bool*        pbSPIVMPFlag
+                                  , TComMvField* pcMvFieldSP
+                                  , UChar*       puhInterDirSP
 #endif
                                    );
@@ -476,5 +474,14 @@
                                     const Int          iSrchRng,
                                     TComMv&      rcMvSrchRngLT,
+#if !MCTS_ENC_CHECK
                                     TComMv&      rcMvSrchRngRB );
+#else
+                                    TComMv&      rcMvSrchRngRB,
+                                    const TComPattern* const pcPatternKey );
+#endif
+
+#if MCTS_ENC_CHECK
+  Void xInitTileBorders(const TComDataCU* const pcCU, TComPattern* pcPatternKey);
+#endif
 
   Void xPatternSearchFast         ( const TComDataCU* const  pcCU,
Index: /trunk/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -113,4 +113,11 @@
 }
 
+Void TEncSlice::updateLambda(TComSlice* pSlice, Double dQP)
+{
+  Int iQP = (Int)dQP;
+  Double dLambda = calculateLambda(pSlice, m_gopID, pSlice->getDepth(), pSlice->getSliceQp(), dQP, iQP);
+
+  setUpLambda(pSlice, dLambda, iQP);
+}
 
 
@@ -188,5 +195,8 @@
   rpcSlice->setPicOutputFlag( true );
   rpcSlice->setPOC( pocCurr );
-#if NH_3D_IC
+  pcPic->setField(isField);
+  m_gopID = iGOPid;
+
+#if NH_3D
   rpcSlice->setApplyIC( false );
 #endif
@@ -252,4 +262,5 @@
     eSliceType = B_SLICE; 
   }
+  m_eSliceTypeBaseView = eSliceTypeBaseView;
 #else
   SliceType eSliceType;
@@ -296,8 +307,11 @@
   // ------------------------------------------------------------------------------------------------------------------
 
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+  dQP = m_pcCfg->getQPForPicture(iGOPid, rpcSlice);
+#else
   dQP = m_pcCfg->getQP();
   if(eSliceType!=I_SLICE)
   {
-    if (!(( m_pcCfg->getMaxDeltaQP() == 0 ) && (dQP == -rpcSlice->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA) ) && (rpcSlice->getPPS()->getTransquantBypassEnableFlag())))
+    if (!(( m_pcCfg->getMaxDeltaQP() == 0) && (!m_pcCfg->getLumaLevelToDeltaQPMapping().isEnabled()) && (dQP == -rpcSlice->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA) ) && (rpcSlice->getPPS()->getTransquantBypassEnabledFlag())))
     {
 #if NH_MV
@@ -310,5 +324,5 @@
 
   // modify QP
-  Int* pdQPs = m_pcCfg->getdQPs();
+  const Int* pdQPs = m_pcCfg->getdQPs();
   if ( pdQPs )
   {
@@ -321,4 +335,5 @@
     m_pcCfg->setDeltaQpRD(0);
   }
+#endif
 
   // ------------------------------------------------------------------------------------------------------------------
@@ -326,4 +341,12 @@
   // ------------------------------------------------------------------------------------------------------------------
 
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+#if NH_MV
+  const Int temporalId=m_pcCfg->getGOPEntry((eSliceTypeBaseView == I_SLICE) ? MAX_GOP : iGOPid).m_temporalId;
+#else
+  const Int temporalId=m_pcCfg->getGOPEntry(iGOPid).m_temporalId;
+#endif
+#endif
+
   Int iQP;
   Double dOrigQP = dQP;
@@ -335,66 +358,5 @@
     dQP = dOrigQP + ((iDQpIdx+1)>>1)*(iDQpIdx%2 ? -1 : 1);
 
-    // compute lambda value
-    Int    NumberBFrames = ( m_pcCfg->getGOPSize() - 1 );
-    Int    SHIFT_QP = 12;
-
-#if FULL_NBIT
-    Int    bitdepth_luma_qp_scale = 6 * (rpcSlice->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) - 8);
-#else
-    Int    bitdepth_luma_qp_scale = 0;
-#endif
-    Double qp_temp = (Double) dQP + bitdepth_luma_qp_scale - SHIFT_QP;
-#if FULL_NBIT
-    Double qp_temp_orig = (Double) dQP - SHIFT_QP;
-#endif
-    // Case #1: I or P-slices (key-frame)
-#if NH_MV
-    Double dQPFactor;
-    if( eSliceType != I_SLICE ) 
-    {
-      dQPFactor = m_pcCfg->getGOPEntry( (eSliceTypeBaseView == I_SLICE) ? MAX_GOP : iGOPid ).m_QPFactor;
-    }
-    else
-#else
-    Double dQPFactor = m_pcCfg->getGOPEntry(iGOPid).m_QPFactor;
-    if ( eSliceType==I_SLICE )
-#endif
-    {
-      if (m_pcCfg->getIntraQpFactor()>=0.0 && m_pcCfg->getGOPEntry(iGOPid).m_sliceType != I_SLICE)
-      {
-        dQPFactor=m_pcCfg->getIntraQpFactor();
-      }
-      else
-      {
-        Double dLambda_scale = 1.0 - Clip3( 0.0, 0.5, 0.05*(Double)(isField ? NumberBFrames/2 : NumberBFrames) );
-        
-        dQPFactor=0.57*dLambda_scale;
-      }
-    }
-    dLambda = dQPFactor*pow( 2.0, qp_temp/3.0 );
-
-    if ( depth>0 )
-    {
-#if FULL_NBIT
-        dLambda *= Clip3( 2.00, 4.00, (qp_temp_orig / 6.0) ); // (j == B_SLICE && p_cur_frm->layer != 0 )
-#else
-        dLambda *= Clip3( 2.00, 4.00, (qp_temp / 6.0) ); // (j == B_SLICE && p_cur_frm->layer != 0 )
-#endif
-    }
-
-    // if hadamard is used in ME process
-    if ( !m_pcCfg->getUseHADME() && rpcSlice->getSliceType( ) != I_SLICE )
-    {
-      dLambda *= 0.95;
-    }
-
-#if W0062_RECALCULATE_QP_TO_ALIGN_WITH_LAMBDA
-    Double lambdaRef = 0.57*pow(2.0, qp_temp/3.0);
-    // QP correction due to modified lambda
-    Double qpOffset = floor((3.0*log(dLambda/lambdaRef)/log(2.0)) +0.5);
-    dQP += qpOffset;
-#endif
-
-    iQP = max( -rpcSlice->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA), min( MAX_QP, (Int) floor( dQP + 0.5 ) ) );
+    dLambda = calculateLambda(rpcSlice, iGOPid, depth, dQP, dQP, iQP );
 
     m_vdRdPicLambda[iDQpIdx] = dLambda;
@@ -409,4 +371,5 @@
 
 
+#if !X0038_LAMBDA_FROM_QP_CAPABILITY
 #if NH_MV
   const Int temporalId=m_pcCfg->getGOPEntry((eSliceTypeBaseView == I_SLICE) ? MAX_GOP : iGOPid).m_temporalId;
@@ -415,6 +378,6 @@
 #endif
   const std::vector<Double> &intraLambdaModifiers=m_pcCfg->getIntraLambdaModifier();
-
-#if W0038_CQP_ADJ
+#endif
+
   if(rpcSlice->getPPS()->getSliceChromaQpFlag())
   {
@@ -435,6 +398,6 @@
     rpcSlice->setSliceChromaQpDelta( COMPONENT_Cr, 0 );
   }
-#endif
-
+
+#if !X0038_LAMBDA_FROM_QP_CAPABILITY
   Double lambdaModifier;
   if( rpcSlice->getSliceType( ) != I_SLICE || intraLambdaModifiers.empty())
@@ -448,4 +411,6 @@
 
   dLambda *= lambdaModifier;
+#endif
+
   setUpLambda(rpcSlice, dLambda, iQP);
 
@@ -507,8 +472,4 @@
 #endif
   rpcSlice->setSliceQpDelta      ( 0 );
-#if !W0038_CQP_ADJ
-  rpcSlice->setSliceChromaQpDelta( COMPONENT_Cb, 0 );
-  rpcSlice->setSliceChromaQpDelta( COMPONENT_Cr, 0 );
-#endif
   rpcSlice->setUseChromaQpAdj( rpcSlice->getPPS()->getPpsRangeExtension().getChromaQpOffsetListEnabledFlag() );
 #if NH_MV
@@ -530,5 +491,5 @@
   {
     rpcSlice->setDeblockingFilterOverrideFlag( rpcSlice->getPPS()->getDeblockingFilterOverrideEnabledFlag() );
-    rpcSlice->setDeblockingFilterDisable( rpcSlice->getPPS()->getPicDisableDeblockingFilterFlag() );
+    rpcSlice->setDeblockingFilterDisable( rpcSlice->getPPS()->getPPSDeblockingFilterDisabledFlag() );
     if ( !rpcSlice->getDeblockingFilterDisable())
     {
@@ -573,9 +534,110 @@
   rpcSlice->setSliceSegmentMode     ( m_pcCfg->getSliceSegmentMode()     );
   rpcSlice->setSliceSegmentArgument ( m_pcCfg->getSliceSegmentArgument() );
-#if NH_3D_IV_MERGE
+#if NH_3D
 #else
   rpcSlice->setMaxNumMergeCand        ( m_pcCfg->getMaxNumMergeCand()        );
 #endif
 }
+
+Double TEncSlice::calculateLambda( const TComSlice* slice,
+                                   const Int        GOPid, // entry in the GOP table
+                                   const Int        depth, // slice GOP hierarchical depth.
+                                   const Double     refQP, // initial slice-level QP
+                                   const Double     dQP,   // initial double-precision QP
+                                         Int        &iQP )  // returned integer QP.
+{
+  enum   SliceType eSliceType    = slice->getSliceType();
+  const  Bool      isField       = slice->getPic()->isField();
+  const  Int       NumberBFrames = ( m_pcCfg->getGOPSize() - 1 );
+  const  Int       SHIFT_QP      = 12;
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+  const Int temporalId=m_pcCfg->getGOPEntry(GOPid).m_temporalId;
+  const std::vector<Double> &intraLambdaModifiers=m_pcCfg->getIntraLambdaModifier();
+#endif
+
+#if FULL_NBIT
+  Int    bitdepth_luma_qp_scale = 6 * (slice->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) - 8);
+#else
+  Int    bitdepth_luma_qp_scale = 0;
+#endif
+  Double qp_temp = dQP + bitdepth_luma_qp_scale - SHIFT_QP;
+  // Case #1: I or P-slices (key-frame)
+#if NH_MV
+  Double dQPFactor = m_pcCfg->getGOPEntry( (m_eSliceTypeBaseView == I_SLICE) ? MAX_GOP : GOPid ).m_QPFactor;
+#else
+  Double dQPFactor = m_pcCfg->getGOPEntry(GOPid).m_QPFactor;
+#endif
+  if ( eSliceType==I_SLICE )
+  {
+    if (m_pcCfg->getIntraQpFactor()>=0.0 && m_pcCfg->getGOPEntry(GOPid).m_sliceType != I_SLICE)
+    {
+      dQPFactor=m_pcCfg->getIntraQpFactor();
+    }
+    else
+    {
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+      if(m_pcCfg->getLambdaFromQPEnable())
+      {
+        dQPFactor=0.57;
+      }
+      else
+      {
+#endif
+        Double dLambda_scale = 1.0 - Clip3( 0.0, 0.5, 0.05*(Double)(isField ? NumberBFrames/2 : NumberBFrames) );
+        dQPFactor=0.57*dLambda_scale;
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+      }
+#endif
+    }
+  }
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+  else if( m_pcCfg->getLambdaFromQPEnable() )
+  {
+    dQPFactor=0.57;
+  }
+#endif
+
+  Double dLambda = dQPFactor*pow( 2.0, qp_temp/3.0 );
+
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+  if( !(m_pcCfg->getLambdaFromQPEnable()) && depth>0 )
+#else
+  if ( depth>0 )
+#endif
+  {
+#if FULL_NBIT
+    Double qp_temp_ref_orig = refQP - SHIFT_QP;
+    dLambda *= Clip3( 2.00, 4.00, (qp_temp_ref_orig / 6.0) ); // (j == B_SLICE && p_cur_frm->layer != 0 )
+#else
+    Double qp_temp_ref = refQP + bitdepth_luma_qp_scale - SHIFT_QP;
+    dLambda *= Clip3( 2.00, 4.00, (qp_temp_ref / 6.0) ); // (j == B_SLICE && p_cur_frm->layer != 0 )
+#endif
+  }
+
+  // if hadamard is used in ME process
+  if ( !m_pcCfg->getUseHADME() && slice->getSliceType( ) != I_SLICE )
+  {
+    dLambda *= 0.95;
+  }
+
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+  Double lambdaModifier;
+  if( eSliceType != I_SLICE || intraLambdaModifiers.empty())
+  {
+    lambdaModifier = m_pcCfg->getLambdaModifier( temporalId );
+  }
+  else
+  {
+    lambdaModifier = intraLambdaModifiers[ (temporalId < intraLambdaModifiers.size()) ? temporalId : (intraLambdaModifiers.size()-1) ];
+  }
+  dLambda *= lambdaModifier;
+#endif
+
+  iQP = max( -slice->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA), min( MAX_QP, (Int) floor( dQP + 0.5 ) ) );
+
+  // NOTE: the lambda modifiers that are sometimes applied later might be best always applied in here.
+  return dLambda;
+}
+
 
 Void TEncSlice::resetQP( TComPic* pic, Int sliceQP, Double lambda )
@@ -835,5 +897,5 @@
 #endif
 
-#if NH_3D_IC
+#if NH_3D
   if ( m_pcCfg->getViewIndex() && m_pcCfg->getUseIC() &&
        !( ( pcSlice->getSliceType() == P_SLICE && pcSlice->getPPS()->getUseWP() ) || ( pcSlice->getSliceType() == B_SLICE && pcSlice->getPPS()->getWPBiPred() ) )
@@ -1213,5 +1275,5 @@
     }
 
-#if NH_3D_QTLPC
+#if NH_3D
     pcPic->setReduceBitsFlag(true);
 #endif
@@ -1285,5 +1347,5 @@
       }
     }
-#if NH_3D_QTLPC
+#if NH_3D
     pcPic->setReduceBitsFlag(false);
 #endif
Index: /trunk/source/Lib/TLibEncoder/TEncSlice.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSlice.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSlice.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -93,6 +93,6 @@
 #else
   UInt64                  m_uiPicDist;                          ///< total distortion for the picture
-#endif
-  Double                  m_dPicRdCost;                         ///< picture-level RD cost
+#endif  
+ Double                  m_dPicRdCost;                         ///< picture-level RD cost
   std::vector<Double>     m_vdRdPicLambda;                      ///< array of lambda candidates
   std::vector<Double>     m_vdRdPicQp;                          ///< array of picture QP candidates (double-type for lambda)
@@ -103,5 +103,10 @@
   TEncSbac                m_entropyCodingSyncContextState;      ///< context storate for state of contexts at the wavefront/WPP/entropy-coding-sync second CTU of tile-row
   SliceType               m_encCABACTableIdx;
+  Int                     m_gopID;
+#if NH_MV
+  SliceType               m_eSliceTypeBaseView;
+#endif
 
+  Double   calculateLambda( const TComSlice* pSlice, const Int GOPid, const Int depth, const Double refQP, const Double dQP, Int &iQP );
   Void     setUpLambda(TComSlice* slice, const Double dLambda, Int iQP);
   Void     calculateBoundingCtuTsAddrForSlice(UInt &startCtuTSAddrSlice, UInt &boundingCtuTSAddrSlice, Bool &haveReachedTileBoundary, TComPic* pcPic, const Int sliceMode, const Int sliceArgument);
@@ -123,5 +128,10 @@
                                 const Int iGOPid,   TComSlice*& rpcSlice, const Bool isField );
 #endif
+
   Void    resetQP             ( TComPic* pic, Int sliceQP, Double lambda );
+  Void    setGopID( Int iGopID )      { m_gopID = iGopID; }
+  Int     getGopID() const            { return m_gopID;   }
+  Void    updateLambda(TComSlice* pSlice, Double dQP);
+
   // compress and encode slice
   Void    precompressSlice    ( TComPic* pcPic                                     );      ///< precompress slice for multi-loop slice-level QP opt.
